<template>
  <v-container fluid class="pt-0">
    <v-row no-gutters>
      <v-col>
        <SearchField/>
      </v-col>
    </v-row>
    <v-row class="section">
      <v-col>
        <SectionTitle title="Национальные проекты, реализуемые в Тюменской области"/>

        <v-row>
          <template
            v-if="categoriesLoadStatus === 'loading'"
          >
            <v-col
              lg="3"
              md="6"
              cols="12"
              v-for="n in 8"
              :key="n"
            >
              <v-skeleton-loader
                transition="scale-transition"
                type="article"
              ></v-skeleton-loader>
            </v-col>
          </template>

          <template
            v-if="categoriesLoadStatus === 'success'"
          >
            <v-col
              lg="3"
              md="6"
              cols="12"
              v-for="(category, index) in categories"
              :key="index"
            >
              <CategoryStatus
                :id="category.id"
                :title="category.name"
                :icon="category.icon"
                :count="category.projectsCount"
              />
            </v-col>
          </template>
        </v-row>
      </v-col>
    </v-row>

    <v-row class="section">
      <v-col>
        <SectionTitle title="Новое">
          <v-img
            src="../assets/img/useful-icon-2.png"
            contain
            width="30"
            class="mr-4 float-left"
          />
        </SectionTitle>

        <v-row>
          <template
            v-if="latestProjectsStatus === 'loading' || categoriesLoadStatus === 'loading'"
          >
            <v-col
              v-for="n in 6"
              :key="n"
              :cols="n < 3 ? 12 : 3"
              :md="n < 3 ? 6 : 3"
            >
              <v-skeleton-loader
                transition="scale-transition"
                type="card"
              ></v-skeleton-loader>
            </v-col>
          </template>

          <template
            v-if="latestProjectsStatus === 'success' && categoriesLoadStatus === 'success'"
          >
            <v-col
              v-for="(project, index) in latestProjects"
              :key="index"
              :cols="index < 2 ? 12 : 3"
              :md="index < 2 ? 6 : 3"
            >
              <ProjectShort1
                v-if="index < 2"
                :id="project.id"
                :name="project.name"
                :category="categories[project.category_id-1].name"
                :icon="categories[project.category_id-1].icon"
                :photo="project.photo"
              />

              <ProjectShort2
                class="d-none d-md-block"
                v-if="index >= 2"
                :id="project.id"
                :name="project.name"
                :category="categories[project.category_id-1].name"
                :icon="categories[project.category_id-1].icon"
                :photo="project.photo"
                :color="categories[project.category_id-1].color"
              />
            </v-col>
          </template>
        </v-row>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
  import CategoryStatus from '../components/CategoryStatus';
  import SearchField from '../components/SearchField';
  import SectionTitle from '../components/SectionTitle';
  import ProjectShort1 from '../components/ProjectShort1';
  import ProjectShort2 from '../components/ProjectShort2';
  import {mapState} from 'vuex';

  export default {
    name: 'Home',
    components: {ProjectShort2, ProjectShort1, SectionTitle, SearchField, CategoryStatus},
    computed: {
      ...mapState('categories', [
        'categories',
        'categoriesLoadStatus',
      ]),
      ...mapState('projects', [
        'latestProjects',
        'latestProjectsStatus',
      ]),
    },
    created() {
      this.$store.dispatch('projects/getLatestProjects');
    },
  };
</script>

<style scoped>
  .section {
    margin-top: 40px;
  }

</style>
